# Wwise Theme Toolset

This folder contains:
 * The factory Wwise themes
 * The toolset used to build new themes

## Theme Structure

Each theme folder is composed of:

| file | description |
| --- |---|
| main.json      | The entry point for the theme definition. This is where all colors are read by Wwise. |
| *.bmp / *.png | These are all image files used by the theme system. Each file must be present. |
| *.scss | The theme source files (Sass format), used to generate the main.json file. |

The .scss files are Sass files. Wwise does not read Sass files. Instead Wwise reads the main.json files, which is generated by the theme toolset. The Sass format is used to define the colors being used in the themes. Sass offers flexible ways of re-using content across files and modern editors support it, making it very convenient to edit themes.

The Audiokinetic team has been using **Visual Studio Code** to edit the themes Sass files, which provide excellent Sass support.

## Creating themes

To create a new theme, we recommend making a copy of an existing theme folder, and modifying it. We don't recommend modifying the factory themes directly, as you would need to re-install Wwise to restore the original state.

## Installing the toolset

To install the toolset, you need to have the most recent **Node.js** LTS installed.

To install dependencies and build the toolset:

1. Open a Command Prompt or Powershell in the Themes folder
1. Type `npm install`
1. Type `npm run build`

## Building a theme

Wwise themes are built from the Sass files present in the folder. First make sure you installed the toolset.

### Using Visual Studio Code

1. Open the `Themes` folder in Visual Studio Code
1. Press `CTRL+SHIFT+B`

Notice the message 'Job's done!' when finished. 

### Using command line

1. Open a Command Prompt or Powershell in Themes folder
1. Type: `node index.js`

Every time the themes are built, Wwise is updated live after building the themes. To activate this function, you must make sure WAAPI is enabled in Wwise, from the **Wwise User Preferences**.